'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clearsAll = clearsAll;
exports.setsAll = setsAll;
exports.getsAll = getsAll;
exports.sets = sets;
exports.gets = gets;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * meta state
 */

var prefix = '__meta_state__';

function clearsAll() {
  var _this = this;

  Object.keys(this.state).forEach(function (key) {
    if (key.startsWith(prefix)) {
      _this.setState(_defineProperty({}, key, ''));
    }
  });
}

function setsAll(obj) {
  var _this2 = this;

  Object.keys(obj).forEach(function (key) {
    sets.call(_this2, key, obj[key]);
  });
}

function getsAll() {
  var _this3 = this;

  var result = {};

  Object.keys(this.state).forEach(function (key) {
    if (key.startsWith(prefix)) {
      var newKey = key.replace(prefix, '').replace(/[_-][a-z]/ig, function (s) {
        console.warn('warn: will remove replace /[_-][a-z]/ig');
        return s.slice(1).toUpperCase();
      });

      result[newKey] = _this3.state[key];
    }
  });

  return result;
}

function sets(key, val) {
  this.setState(_defineProperty({}, prefix + key, val));
}

function gets(key) {
  return this.state[prefix + key];
}

/**
 * private
 */

function throwError(msg) {
  throw new TypeError(msg);
}