'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.focus = focus;
exports.clear = clear;

var _reactDom = require('react-dom');

/**
 * Usage
 *
 *   this::focus('some')
 *
 * @param {String} ref
 */

function focus(ref) {
  ref = this.refs[ref];
  if (ref) {
    (0, _reactDom.findDOMNode)(ref).focus();
  }
}

/**
 * Usage
 *
 *   this::clear('some')
 *
 * @param {String} ref
 */

function clear(ref) {
  ref = this.refs[ref];
  if (ref) {
    ref.value = '';
  }
}